// BrowseFolder.cpp : implementation file
//

#include "stdafx.h"
#include "Setup.h"
#include "BrowseFolder.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBrowseFolder dialog

extern CSetupApp theApp;

CBrowseFolder::CBrowseFolder(CWnd* pParent /*=NULL*/)
	: CDialog(CBrowseFolder::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBrowseFolder)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_FolderList.SetSize(10,5);
	
}

void CBrowseFolder::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBrowseFolder)
	DDX_Control(pDX, IDC_PATH, m_Path);
	DDX_Control(pDX, IDC_HIDDEN_LIST, m_Sort);
	DDX_Control(pDX, IDC_TREE, m_Folder);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBrowseFolder, CDialog)
	//{{AFX_MSG_MAP(CBrowseFolder)
	ON_BN_CLICKED(IDOK, OnSelect)
	ON_NOTIFY(TVN_GETDISPINFO, IDC_TREE, OnGetdispinfoTree)
	ON_NOTIFY(TVN_ITEMEXPANDED, IDC_TREE, OnItemexpandedTree)
	ON_NOTIFY(TVN_ITEMEXPANDING, IDC_TREE, OnItemexpandingTree)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE, OnSelChanged)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBrowseFolder message handlers

void CBrowseFolder::OnCancel() 
{
	CDialog::OnCancel();
}

void CBrowseFolder::OnSelect() 
{
	CString Path;
	int i;
	m_Path.GetWindowText(Path);
	Path.TrimLeft();
	Path.TrimRight();
	if(Path.GetLength()==0)
	{
		AfxMessageBox("No Folder selected.",MB_OK|MB_ICONSTOP);
	}
	else if(Path.FindOneOf("/*?\"<>|")!=-1)
	{
		AfxMessageBox("Installation Folder cannot contain the following characters.\n/*?\"<>|",MB_OK|MB_ICONSTOP);
	}
	else if(Path.GetLength()<3)
	{
		AfxMessageBox("Full path for the Installation Folder must be specified.",MB_OK|MB_ICONSTOP);
	}
	else if(Path[1]!=':' || Path[2]!='\\')
	{
		AfxMessageBox("Full path for the Installation Folder must be specified.",MB_OK|MB_ICONSTOP);
	}
	else
	{
		i=Path.GetLength();
		if(Path[i-1]!='\\')
			Path+='\\';
		if(SetCurrentDirectory(Path)==FALSE)
		{
			if(AfxMessageBox("The specified folder does not exist.\nCreate new folder?",MB_YESNO)!=IDYES)
				return;
		}
		else
		{
			if(AfxMessageBox("The specified folder already exists.\nAre you sure you want to install in it?",MB_YESNO)!=IDYES)
				return;
		}
		theApp.InstFolder=Path;
		EndDialog(IDOK);
	}
}

BOOL CBrowseFolder::OnInitDialog() 
{
	char Buffer[79];
	CString Temp1;
	HTREEITEM hParent;
	CWaitCursor wait;    // display wait cursor
	CDialog::OnInitDialog();
	BOOL ret=IsWindow(m_Folder.m_hWnd);

	m_Path.SetWindowText(theApp.InstFolder);

//Initialise m_Folder Tree Control
	CleanUp();
	AddImages();
	m_Folder.SetImageList(&Icons,TVSIL_NORMAL);
	hParent=m_Folder.InsertItem("My Computer",2,2);
	m_Folder.SetItemData(hParent,m_FolderList.Add(" "));
	GetLogicalDriveStrings(78,Buffer);
	Temp1.Empty();
	for(int i=0;i<=78;i++)
	{
		if(Buffer[i]=='\0')
		{
			if(Temp1.GetLength()==0)
				break;
			else
			{
				Temp1.MakeUpper();				
				AddDrive((LPCSTR)Temp1);
				Temp1.Empty();
			}
		}
		else if(Buffer[i]=='\\');
		else
		{
			Temp1+=Buffer[i];
		}
		
	}

	m_Folder.Expand(hParent,TVE_EXPAND);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CBrowseFolder::CleanUp()
{
	m_FolderList.RemoveAll();
	Icons.DeleteImageList();
}

BOOL CBrowseFolder::AddDrive(LPCSTR Path)
{
	CString Temp=Path;
	int Index;
	SHFILEINFO Shell;
	TV_INSERTSTRUCT insert;
	Temp+='\\';
	SHGetFileInfo(Temp,0,&Shell,sizeof(Shell),SHGFI_DISPLAYNAME|SHGFI_ICON|SHGFI_SMALLICON);
	Index=Icons.Add(Shell.hIcon);
	insert.item.lParam=(int) m_FolderList.Add(Path);
	insert.hParent=m_Folder.GetRootItem();
	insert.hInsertAfter=TVI_LAST;
	insert.item.mask=TVIF_CHILDREN | TVIF_PARAM|TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE;
	insert.item.pszText=Shell.szDisplayName;   
	insert.item.cchTextMax=strlen(Shell.szDisplayName)+1;
	insert.item.iImage=Index;	
	insert.item.iSelectedImage=Index;
	insert.item.cChildren=1; 
	m_Folder.InsertItem(&insert);
	return TRUE;
}

BOOL CBrowseFolder::Fill_1_Level(LPCSTR path, HTREEITEM hParent)
{
	char pathparam[_MAX_PATH];
	BOOL found=FALSE;
	TV_INSERTSTRUCT insert;
	HTREEITEM hItem;
	HANDLE hFind;
	CString Temp;
	WIN32_FIND_DATA find_data;
	sprintf(pathparam,"%s\\*.*",path);
	Temp="Error accessing ";
	Temp+=path;
	Temp+='\\';
	do 
	{
		hFind=FindFirstFile(pathparam,&find_data);
		if(hFind==INVALID_HANDLE_VALUE)
		{
			if(AfxMessageBox(Temp,MB_RETRYCANCEL|MB_ICONSTOP)!=IDRETRY)
				return FALSE;
		}
	}while(hFind==INVALID_HANDLE_VALUE);
	
	do
	{
		if(strcmp(find_data.cFileName,".")==0 
				|| strcmp(find_data.cFileName,"..")==0);//ignore . and .. folders
		
		else if(find_data.dwFileAttributes==(find_data.dwFileAttributes|FILE_ATTRIBUTE_SYSTEM));//ignore system folders
		else if(find_data.dwFileAttributes==(find_data.dwFileAttributes|FILE_ATTRIBUTE_READONLY));//ignore read only folders

		else if(find_data.dwFileAttributes==(find_data.dwFileAttributes|FILE_ATTRIBUTE_DIRECTORY))
		{
			sprintf(pathparam,"%s\\%s",path,find_data.cFileName);
			insert.item.lParam=(int) m_FolderList.Add(pathparam);
			insert.hParent=hParent;
			insert.hInsertAfter=TVI_SORT;
			insert.item.mask=TVIF_CHILDREN | TVIF_PARAM|TVIF_TEXT| TVIF_IMAGE|TVIF_SELECTEDIMAGE;
			insert.item.iImage=1;
			insert.item.iSelectedImage=0;
			insert.item.pszText=find_data.cFileName;
			insert.item.cchTextMax=strlen(find_data.cFileName)+1;
			insert.item.cChildren=I_CHILDRENCALLBACK; 

			hItem=m_Folder.InsertItem(&insert);
			
			found=TRUE;
		}
	}while(FindNextFile(hFind,&find_data) && hFind!=INVALID_HANDLE_VALUE);
	FindClose(hFind);
	return found;
}


void CBrowseFolder::OnGetdispinfoTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	TV_DISPINFO* pTVDispInfo = (TV_DISPINFO*)pNMHDR;
	// TODO: Add your control notification handler code here

	CString path;
	int index=0;
	HTREEITEM hItem;
	hItem=pTVDispInfo->item.hItem;
	index=(int)pTVDispInfo->item.lParam;
	pTVDispInfo->item.mask=pTVDispInfo->item.mask|TVIF_CHILDREN;
	path=m_FolderList.GetAt(index);
	if(Fill_1_Level((LPCSTR)path,hItem))
		pTVDispInfo->item.cChildren=1;
	else
		pTVDispInfo->item.cChildren=0;
	m_Folder.SetItem(& pTVDispInfo->item);
	*pResult=0;
}

void CBrowseFolder::OnItemexpandedTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here

	*pResult = 0;
}

void CBrowseFolder::OnItemexpandingTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here

	UINT state=pNMTreeView->itemNew.state;
	UINT expanded=TVIS_EXPANDEDONCE;
	CString Name;
	int index=(int)pNMTreeView->itemNew.lParam;
	if((state & expanded) != expanded)
	{
		Name=m_FolderList.GetAt(index);
		if( (pNMTreeView->action==TVE_EXPAND) && (Name.GetLength()==2) )
		{
//			Fill_1_Level(Name,pNMTreeView->itemNew.hItem);
			if(Fill_1_Level(Name,pNMTreeView->itemNew.hItem))
				pNMTreeView->itemNew.cChildren=1;
			else
				pNMTreeView->itemNew.cChildren=0;
			m_Folder.SetItem(& pNMTreeView->itemNew);

		}
	}
		*pResult = 0;
}

void CBrowseFolder::OnSelChanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	
	CString Name;
	int index=(int)pNMTreeView->itemNew.lParam;
	Name=m_FolderList.GetAt(index);
	if(Name!=" ")
	{
		Name+='\\';
		m_Path.SetWindowText(Name);	
	}

	*pResult = 0;
}

BOOL CBrowseFolder::AddImages()
{
	HICON hIcon;
	Icons.Create(16, 16,ILC_COLOR16,9,1);
	Icons.SetBkColor(GetSysColor(COLOR_WINDOW));	
	//Loading Icons
	for(int i=IDI_OPEN;i<=IDI_COMPUTER;i++)
	{
		hIcon=theApp.LoadIcon(i);
		Icons.Add(hIcon);
	}
	return TRUE;
}
