/*	Cabinet.cpp
**	implementation of the CCabinet class
*/
#include "stdafx.h"
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include <dos.h>
#include <sys/stat.h>
#include "fdi.h"
#include "Cabinet.h"
#include "CabinetFn.h"

BOOL CCabinet::Extract(char *cabinet_fullpath)
{
	HFDI			hfdi;
	ERF				erf;
	FDICABINETINFO	fdici;
	int				hf;
	char			*p;
	char			cabinet_name[256];
	char			cabinet_path[256];
	
	strcpy(dest_dir,Destination); 

	hfdi = FDICreate(mem_alloc,	mem_free,file_open,file_read,
						file_write,file_close,file_seek,cpu80386,&erf);

	if (hfdi == NULL)
	{
/*		printf("FDICreate() failed: code %d [%s]\n",
			erf.erfOper, return_fdi_error_string((FDIERROR)erf.erfOper)*/
		AfxMessageBox("Failure in extracitng files\nError No: 1001.\nSetup is being aborted.");
		return FALSE;
	}

//Open cabinet file

	hf = file_open(cabinet_fullpath, _O_BINARY | _O_RDONLY | _O_SEQUENTIAL,0);

	if (hf == -1)
	{
		(void) FDIDestroy(hfdi);

		AfxMessageBox("Failure in opening Wall1.cab\nError No: 1002\nSetup is being aborted.");
		return FALSE;
	}
//Check if it is indeed a cabinet

	if (FALSE == FDIIsCabinet(hfdi,	hf,&fdici))// No, it's not a cabinet!
	{
		_close(hf);
		AfxMessageBox("Failure in extracitng files\nWall1.cab seems to be corrupt.\nSetup is being aborted.");
		(void) FDIDestroy(hfdi);
		return FALSE;
	}
	else
	{
		_close(hf);

/*		printf(
			"Information on cabinet file '%s'\n"
			"   Total length of cabinet file : %d\n"
			"   Number of folders in cabinet : %d\n"
			"   Number of files in cabinet   : %d\n"
			"   Cabinet set ID               : %d\n"
			"   Cabinet number in set        : %d\n"
			"   RESERVE area in cabinet?     : %s\n"
			"   Chained to prev cabinet?     : %s\n"
			"   Chained to next cabinet?     : %s\n"
			"\n",
			cabinet_fullpath,
			fdici.cbCabinet,
			fdici.cFolders,
			fdici.cFiles,
			fdici.setID,
			fdici.iCabinet,
			fdici.fReserve == TRUE ? "yes" : "no",
			fdici.hasprev == TRUE ? "yes" : "no",
			fdici.hasnext == TRUE ? "yes" : "no"
		);*/
		if(fdici.setID!=16378)
		{
			if(fdici.setID == 16377)
				AfxMessageBox("Failure in extracitng files\nWall1.cab is not of the expected version.\nSetup is being aborted.");
			else
				AfxMessageBox("Failure in extracitng files\nWall1.cab seems to be corrupt.\nSetup is being aborted.");
			(void) FDIDestroy(hfdi);
			return FALSE;
		}
	}

	p = strrchr(cabinet_fullpath, '\\');

	if (p == NULL)
	{
		strcpy(cabinet_name, cabinet_fullpath);
		strcpy(cabinet_path, "");
	}
	else
	{
		strcpy(cabinet_name, p+1);

		strncpy(cabinet_path, cabinet_fullpath, (int) (p-cabinet_fullpath)+1);
		cabinet_path[ (int) (p-cabinet_fullpath)+1 ] = 0;
	}

	if (TRUE != FDICopy(
		hfdi,
		cabinet_name,
		cabinet_path,
		0,
		notification_function,
		NULL,
		NULL))
	{
/*		printf(
			"FDICopy() failed: code %d [%s]\n",
			erf.erfOper, return_fdi_error_string((FDIERROR)erf.erfOper)
		);*/
	AfxMessageBox("FDICopy() failed.\nFailure in extracitng files\nError No: 1004.\nSetup is being aborted.");
		(void) FDIDestroy(hfdi);
		return FALSE;
	}

	if (FDIDestroy(hfdi) != TRUE)
	{
/*		printf(
			"FDIDestroy() failed: code %d [%s]\n",
			erf.erfOper, return_fdi_error_string((FDIERROR)erf.erfOper)
		);*/
	AfxMessageBox("FDIDestroy() failed.\nFailure in extracitng files\nError No: 1005.\nSetup is being aborted.");
		return FALSE;
	}

	return TRUE;
}
