// Step2.cpp : implementation file
//

#include "stdafx.h"
#include "Setup.h"
#include "Step2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStep2 dialog

extern CSetupApp theApp;

CStep2::CStep2(CWnd* pParent /*=NULL*/)
	: CDialog(CStep2::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStep2)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


void CStep2::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStep2)
	DDX_Control(pDX, IDC_PATH, m_Path);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStep2, CDialog)
	//{{AFX_MSG_MAP(CStep2)
	ON_BN_CLICKED(IDC_BACK, OnBack)
	ON_BN_CLICKED(IDC_NEXT, OnNext)
	ON_BN_CLICKED(IDC_CHANGE, OnChange)
	ON_BN_CLICKED(IDABORT, OnAbort)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStep2 message handlers

void CStep2::OnBack() 
{
	EndDialog(IDC_BACK);	
}

void CStep2::OnNext() 
{
	char str[_MAX_PATH];
	HANDLE handle;
	if(theApp.CreateDirs(theApp.InstFolder,theApp.InstFolder.GetLength())==FALSE)
	{
		AfxMessageBox("Setup encountered an error while creating the installation folder.\nChange installation folder to a valid one.");
		return;
	}
//Checking for disk-space
	GetTempFileName(theApp.InstFolder,"MPJ",0,str);
    handle = CreateFile(
		str,GENERIC_READ | GENERIC_WRITE,0,
		NULL,CREATE_ALWAYS ,
		FILE_ATTRIBUTE_NORMAL|FILE_FLAG_DELETE_ON_CLOSE,
		NULL);
	if(handle==INVALID_HANDLE_VALUE)
	{
		AfxMessageBox("Installation folder seems to be 'read-only'.\nChange installation folder and try again.");
		CloseHandle(handle);
		return;
	}
	SetFilePointer(handle,256000,0,FILE_BEGIN);
	if(SetEndOfFile(handle)==FALSE)
	{
		AfxMessageBox("Installation folder seems does not have the required space of 250KB.\nChange installation folder and try again.");
		CloseHandle(handle);
		return;
	}

	CloseHandle(handle);

//	ShowWindow(SW_HIDE);
	if(m_Step3_Dlg.DoModal()==IDC_BACK)
		ShowWindow(SW_SHOW);
	else
		EndDialog(IDC_NEXT);
}

void CStep2::OnChange() 
{
	if(m_Browse.DoModal()==IDOK)
		m_Path.SetWindowText(theApp.InstFolder);
	UpdateWindow();
}

BOOL CStep2::OnInitDialog() 
{

	HKEY hKey;
	char str[_MAX_PATH+1]="C:\\";
	unsigned long size =sizeof(str);
	CWaitCursor wait;    // display wait cursor
	CDialog::OnInitDialog();
	
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//	Initialise Installation Folder
	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,REGSTR_PATH_SETUP,
			0,KEY_QUERY_VALUE,&hKey)==ERROR_SUCCESS)
	{
		RegQueryValueEx(hKey,"ProgramFilesDir",0,NULL,(BYTE *)str,&size);
		theApp.InstFolder=str;
		RegCloseKey(hKey);
	}
	else
		theApp.InstFolder="C:";
	theApp.InstFolder.TrimRight();
	if(theApp.InstFolder[theApp.InstFolder.GetLength()-1]=='\\')
	{
		theApp.InstFolder.SetAt(theApp.InstFolder.GetLength()-1,' ');
		theApp.InstFolder.TrimRight();
	}
	
	theApp.InstFolder+="\\Wallpaper Changer\\";
	m_Path.SetWindowText(theApp.InstFolder);

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CStep2::OnAbort() 
{
	EndDialog(IDCANCEL);
}

void CStep2::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CWnd *pParent=NULL;
	CDialog::OnShowWindow(bShow, nStatus);
	
	if(bShow==TRUE)
	{
		pParent=GetParent();
		if(pParent!=NULL)
			pParent->ShowWindow(SW_HIDE);
	}
}
