// Step3.cpp : implementation file
//

#include "stdafx.h"
#include "Setup.h"
#include "Step3.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CSetupApp theApp;
/////////////////////////////////////////////////////////////////////////////
// CStep3 dialog


CStep3::CStep3(CWnd* pParent /*=NULL*/)
	: CDialog(CStep3::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStep3)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


void CStep3::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStep3)
	DDX_Control(pDX, IDC_COMBO1, m_List);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStep3, CDialog)
	//{{AFX_MSG_MAP(CStep3)
	ON_BN_CLICKED(IDC_NEXT, OnNext)
	ON_BN_CLICKED(IDC_BACK, OnBack)
	ON_BN_CLICKED(IDABORT, OnAbort)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStep3 message handlers

BOOL CStep3::OnInitDialog() 
{
	LPITEMIDLIST ppidl;
	char Path[_MAX_PATH+1];

	CWaitCursor wait;    // display wait cursor

	CDialog::OnInitDialog();
	
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//Get the Start Menu folder
	
	SHGetSpecialFolderLocation(m_hWnd,CSIDL_PROGRAMS,&ppidl);
	SHGetPathFromIDList(ppidl,Path); 
	theApp.Programs=Path;
	SHGetSpecialFolderLocation(m_hWnd,CSIDL_COMMON_PROGRAMS,&ppidl);
	SHGetPathFromIDList(ppidl,Path); 
	theApp.All_Programs=Path;
	theApp.Programs.TrimRight();
	theApp.Programs.TrimLeft();
	if(theApp.Programs.GetLength()!=0)
	{
		
		GetFolders((LPCSTR)theApp.Programs);
	}
	
	if(theApp.All_Programs.GetLength()!=0)
	{
		
		GetFolders((LPCSTR)theApp.Programs);
	}

	m_List.SetWindowText("Wallpaper Changer");
	m_List.SetEditSel(0,-1);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CStep3::OnNext() 
{
	m_List.GetWindowText(theApp.St_Mnu_Item);
	theApp.St_Mnu_Item.TrimRight();

	if(theApp.St_Mnu_Item.GetLength()==0)
	{
		AfxMessageBox("No item selected in the list box.\nSelect an item and click 'Next'.");
		return;
	}
	//	Check if string contains invalid characters /\:*?"<>|
	if(theApp.St_Mnu_Item.FindOneOf("/\\:*?\"<>|")!=-1)
	{
		AfxMessageBox("Start Menu program item cannot contain the following characters.\n/\\:*?\"<>| ");
		return;
	}
	
//	ShowWindow(SW_HIDE);
	if(m_Step4_dlg.DoModal()==IDC_BACK)
		ShowWindow(SW_SHOW);
	else
		EndDialog(IDC_NEXT);
	
}

void CStep3::OnBack() 
{
	EndDialog(IDC_BACK);
	
}

void CStep3::OnAbort() 
{
	EndDialog(IDCANCEL);
}

BOOL CStep3::GetFolders(LPCSTR Path)
{
	BOOL found=FALSE;
	HANDLE hFind;
	CString Temp=Path;
	Temp+="\\*.*";
	WIN32_FIND_DATA find_data;

	hFind=FindFirstFile((LPCSTR)Temp,&find_data);
	if(hFind==INVALID_HANDLE_VALUE)
	{
		AfxMessageBox("Error reading StartMenu folders",MB_OK|MB_ICONSTOP);
		return FALSE;
	}
	do
	{
		if(strcmp(find_data.cFileName,".")==0 
				|| strcmp(find_data.cFileName,"..")==0);//ignore . and .. folders
		else if(find_data.dwFileAttributes==(find_data.dwFileAttributes|FILE_ATTRIBUTE_DIRECTORY))
		{
			if(m_List.FindStringExact(-1,find_data.cFileName)==CB_ERR)
			{
				m_List.AddString(find_data.cFileName);
				found=TRUE;
			}
		}
		
	}while(FindNextFile(hFind,&find_data) && hFind!=INVALID_HANDLE_VALUE);

	FindClose(hFind);
	return found;
}

void CStep3::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
CWnd *pParent=NULL;
	if(bShow==TRUE)
	{
		pParent=GetParent();
		if(pParent!=NULL)
			pParent->ShowWindow(SW_HIDE);
	}	
}
