// UnInstallDlg.cpp : implementation file
//

#include "stdafx.h"
#include "UnInstall.h"
#include "UnInstallDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUnInstallDlg dialog

CUnInstallDlg::CUnInstallDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUnInstallDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUnInstallDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUnInstallDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUnInstallDlg)
	DDX_Control(pDX, IDC_MESSAGE, m_Message);
	DDX_Control(pDX, IDOK, m_Ok);
	DDX_Control(pDX, IDC_CHECK3, m_Check3);
	DDX_Control(pDX, IDC_CHECK2, m_Check2);
	DDX_Control(pDX, IDC_CHECK1, m_Check1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUnInstallDlg, CDialog)
	//{{AFX_MSG_MAP(CUnInstallDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUnInstallDlg message handlers

BOOL CUnInstallDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	NoOfTimes=0;	
	TimerID=SetTimer(ID_MY_TIMER,1000,NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUnInstallDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUnInstallDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CUnInstallDlg::OnCancel() 
{
	MessageBeep((UINT)-1);
	return;
}

void CUnInstallDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void CUnInstallDlg::OnTimer(UINT nIDEvent) 
{
	KillTimer(TimerID);
	if(NoOfTimes==0)
	{
		NoOfTimes++;
		BeginUninstall();
	}
	CDialog::OnTimer(nIDEvent);
}

void CUnInstallDlg::BeginUninstall()
{
	HKEY hKey,hKey1;
	char str[_MAX_PATH]="";
	char str1[_MAX_PATH]="";
	char str2[_MAX_PATH]="";
	ULONG size=_MAX_PATH,Length=0;
	LONG ret=0;
	
	int i=0,j=0,k=0;
	CString Temp;
	LPSTR lpStr;
	


//Start Uninstallation
	
	//Get Install Folder and Start Menu folder
	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,"SOFTWARE\\Purayidam Software\\Wallpaper Changer\\1.0",
			0,KEY_QUERY_VALUE,&hKey)==ERROR_SUCCESS)
	{
		RegQueryValueEx(hKey,"Installation Folder",0,NULL,(BYTE *)str,&size);
		InstFolder=str;
		size=_MAX_PATH;
		RegQueryValueEx(hKey,"StartMenu Folder",0,NULL,(BYTE *)str,&size);
		StMnuFolder=str;
		RegCloseKey(hKey);
	}
	else
	{
		AfxMessageBox("Registry for Wallpaper Changer 1.0 not found! Uninstallation unsuccessful.",MB_OK|MB_ICONSTOP);
		Unsuccessful();
		return;
	}
	
	// Add entries to the WININIT.ini file so that installation folder and uninstall.exe are deleted on restart

	
	str[0]=0;
	GetModuleFileName(NULL,str,_MAX_PATH);
	GetShortPathName(str,str1,_MAX_PATH);
	Temp="NUL=";
	Temp+=str1;
	i=Temp.GetLength()+2;
	lpStr=Temp.GetBuffer(i);
	lpStr[i-1]='\0';
	WriteToINI(lpStr,i);

	Temp.ReleaseBuffer(-1);
	Temp.Empty();

	
	//Delete Program files and folders
	if(InstFolder.GetLength()==0)
	{
		AfxMessageBox("Registry for Wallpaper Changer 1.0 corrupt! Uninstallation unsuccessful.",MB_OK|MB_ICONSTOP);
		Unsuccessful();
		return;
	}
	Temp=InstFolder;
	Temp+="Wallpaper Changer.exe";
	DeleteFile(Temp);
	
	Temp=InstFolder;
	Temp+="Wallpaper Changer.hlp";
	DeleteFile(Temp);
	
	Temp=InstFolder;
	Temp+="Wallpaper Changer.GID";
	DeleteFile(Temp);
	
	Temp=InstFolder;
	Temp+="Wallpaper Changer.cnt";
	DeleteFile(Temp);

	Temp=InstFolder;
	Temp+="Readme.txt";
	DeleteFile(Temp);

	Temp=InstFolder;
	RemoveDirectory(Temp);

	m_Check1.ShowWindow(SW_SHOW);
	UpdateWindow();
	
	
	//Deleting Start-Menu Files and Folders
	Temp=StMnuFolder;
	Temp+="\\Configure Wallpaper changer.lnk";
	DeleteFile(Temp);
	Temp=StMnuFolder;
	Temp+="\\Readme.lnk";
	DeleteFile(Temp);
	RemoveDirectory(StMnuFolder);
	m_Check2.ShowWindow(SW_SHOW);
	UpdateWindow();
	//Deleting Registry entries
		//Product key
	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,"SOFTWARE\\Purayidam Software",
		0,KEY_SET_VALUE,&hKey)==ERROR_SUCCESS)
	{
		RegDeleteKey(hKey,"Wallpaper Changer");
		ret=RegEnumKey(hKey,0,str,_MAX_PATH);
		RegCloseKey(hKey);
	}
	if(ret=ERROR_NO_MORE_ITEMS)
	{
		if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,"SOFTWARE",
			0,KEY_SET_VALUE,&hKey)==ERROR_SUCCESS)
		{
			RegDeleteKey(hKey,"Purayidam Software");
			RegCloseKey(hKey);
		}
	}
		//Apps path key
	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths",
		0,KEY_SET_VALUE,&hKey)==ERROR_SUCCESS)
	{
		RegDeleteKey(hKey,"Wallpaper Changer.exe");
		RegCloseKey(hKey);
	}
	//Run key
	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,REGSTR_PATH_RUN,
		0,KEY_SET_VALUE,&hKey)==ERROR_SUCCESS)
	{
		RegDeleteValue(hKey,"Wallpaper Changer");
		RegCloseKey(hKey);
	}
	//Uninstall Key
	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,"Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall",
		0,KEY_SET_VALUE,&hKey)==ERROR_SUCCESS)
	{
		RegDeleteKey(hKey,"Wallpaper Changer");
		RegCloseKey(hKey);
	}
	
	
	//Configuration entries for each user	
	//HKEY_USERS\.Default\Software\Purayidam Software

	if(RegOpenKeyEx(HKEY_USERS,NULL,
		0,KEY_QUERY_VALUE,&hKey)==ERROR_SUCCESS)
	{
		i=0;
		while(RegEnumKey(hKey,i,str,_MAX_PATH)!=ERROR_NO_MORE_ITEMS)
		{
			Temp=str;
			Temp+="\\Software\\Purayidam Software";
			if(RegOpenKeyEx(hKey,(LPCSTR)Temp,
				0,KEY_SET_VALUE,&hKey1)==ERROR_SUCCESS)
			{
				RegDeleteKey(hKey1,"Wallpaper Changer 1.0");
				ret=RegEnumKey(hKey1,i,str1,_MAX_PATH);
				RegCloseKey(hKey1);
				if(ret==ERROR_NO_MORE_ITEMS)//if key is empty delete it
				{
					Temp=str;
					Temp+="\\Software";
					if(RegOpenKeyEx(hKey,(LPCSTR)Temp,
						0,KEY_SET_VALUE,&hKey1)==ERROR_SUCCESS)
					{
						RegDeleteKey(hKey1,"Purayidam Software");
						RegCloseKey(hKey1);
					}
				}
			}
			i++;
		}
		RegCloseKey(hKey);
	}

	m_Check3.ShowWindow(SW_SHOW);
	m_Message.ShowWindow(SW_SHOW);
	m_Ok.EnableWindow();
	UpdateWindow();

	MessageBeep(MB_ICONEXCLAMATION);
}


void CUnInstallDlg::Unsuccessful()
{
	EndDialog(IDOK);
}

BOOL CUnInstallDlg::WriteToINI(LPCSTR lpcEntry,ULONG length)
{
	HANDLE handle;
	char szWinInitFile[_MAX_PATH]="";
	DWORD fsize=0,counter=0;
	LPSTR lpStr;
	CString Section;
    
	GetWindowsDirectory(szWinInitFile,_MAX_PATH);
	lstrcat(szWinInitFile, "\\WININIT.INI");
	handle = CreateFile(
		szWinInitFile,
		GENERIC_READ,FILE_SHARE_READ,
		NULL,OPEN_EXISTING,
		0,NULL);
	if(handle!=INVALID_HANDLE_VALUE)
	{
		fsize=GetFileSize(handle,NULL);
		CloseHandle(handle);
	}
	lpStr=Section.GetBuffer(fsize+length);
	
	counter=GetPrivateProfileSection("Rename",lpStr,fsize+length,szWinInitFile);
	for(WORD i=0;i<length;counter++,i++)
	{
		lpStr[counter]=lpcEntry[i];
	}

	WritePrivateProfileSection("Rename",lpStr,szWinInitFile);
	
	return TRUE;
}

