// Background Changer.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Background Changer.h"
#include "Background ChangerDlg.h"
#include "SplashScreen.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBackgroundChangerApp

BEGIN_MESSAGE_MAP(CBackgroundChangerApp, CWinApp)
	//{{AFX_MSG_MAP(CBackgroundChangerApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBackgroundChangerApp construction

CBackgroundChangerApp::CBackgroundChangerApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CBackgroundChangerApp object

CBackgroundChangerApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CBackgroundChangerApp initialization

BOOL CBackgroundChangerApp::InitInstance()
{
	CString CmdLine;
	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox("Failed to initialise OLE libraries");
		return FALSE;
	}

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif
	
	SetRegistryKey(_T("Purayidam Software"));

	CmdLine=GetCommandLine();
	if( CmdLine.Find("/Change") == -1 )
	{	// App Launched in Configuration Mode
		CBackgroundChangerDlg dlg;
		m_pMainWnd = &dlg;
		int nResponse = dlg.DoModal();
		if (nResponse == IDOK)
		{
			// TODO: Place code here to handle when the dialog is
			//  dismissed with OK
		}
		else if (nResponse == IDCANCEL)
		{
			// TODO: Place code here to handle when the dialog is
			//  dismissed with Cancel
		}
	}
	else
	{
	//App Launched in Change-Mode
		CSplashScreen m_Sp_Scr;
		CString Files,Temp,First,Second,Next_in_line,Last,
			Enable,Arrangement,Configured;
		int i,j,counter;
		BOOL Found=FALSE;
		
		//Retrieve Configuration from the Registry
		Files=GetProfileString("Configuration","Files","|");
		Next_in_line=GetProfileString("Configuration","Next_in_line","");
		Enable=GetProfileString("Configuration","Status","1");//1-Enabled; 0-Disabled
//		Splash=GetProfileString("Configuration","Show Splash","1");//1-Enabled; 0-Disabled
		Arrangement=GetProfileString("Configuration","Arrangement","1");//0-Centred, 1- Tiled, 2-Stretched
		Configured=GetProfileString("Configuration","Configured","0");
		
		if(Configured=="0")
		{
			i=AfxMessageBox("You have not configured the Wallpaper Changer application. Would you like to do so now?",MB_YESNO);
			if(i==IDYES)
			{
				i=CmdLine.Find('/');
				if(i==-1)
					return FALSE;
				CmdLine.GetBufferSetLength(i);
				CmdLine.ReleaseBuffer(i);
				WinExec((LPCSTR)CmdLine,SW_SHOWNORMAL);
			}
			return FALSE;
		}

		if(Enable=="0")
		{
			MessageBeep((UINT)-1);
			return FALSE;
		}
		m_Sp_Scr.Create(CSplashScreen::IDD,NULL);
		m_Sp_Scr.UpdateWindow();

		//Process the list of files
		for(counter=0,i=0,j=Files.GetLength();i<j;i++)
		{
			if (Files[i]!='|')
				Temp+=Files[i];
			else 
			{
				Temp.TrimLeft();
				Temp.TrimRight();
				if(Temp.GetLength()!=0)
				{
					counter++;
					Last=Temp;
					if(Found==TRUE)//Last is the new Next-in-line
						break;
					if(First=="")
						First=Temp;
					else if(Second=="")
						Second=Temp;
					if(Temp==Next_in_line)
							Found=TRUE;
				}
				Temp.Empty();
			}
		}//end of for loop
		if(counter==0)
			return FALSE;

		//Set the Wallpaper and determine the new next-in line
		//SetArrangement(Arrangement);
		if(Found==TRUE)
		{
			if(Last==Next_in_line)//Next in line is the last item
			{
				SetWallpaper(Next_in_line, Arrangement);
				Next_in_line=First;
			}
			else
			{
				SetWallpaper(Next_in_line, Arrangement);
				Next_in_line=Last;
			}
		}//end-if if found
		else //if not found
		{
			SetWallpaper(First);
			if(Second=="")
				Next_in_line=First;
			else
				Next_in_line=Second;
		}
		//Save the new configuration
		WriteProfileString("Configuration","Next_in_line",Next_in_line);
		m_Sp_Scr.UpdateWindow();
		Sleep(1000);//To give the user a chance to read the splash screen!!!!!

	}
	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

void CBackgroundChangerApp::SetWallpaper(CString Name, CString Arrangement )
{
	HRESULT hr;
	wchar_t Wallpaper[ MAX_PATH ];
	int Style;
	//0-Centred, 1- Tiled, 2-Stretched
	switch ( Arrangement[0] )
	{
	case '0':
		Style = WPSTYLE_CENTER ;
		break;
	case '2':
		Style = WPSTYLE_STRETCH ;
		break;
	default:	// '1'
		Style = WPSTYLE_TILE ;
	}

	//Style = ;
	int Length = Name.GetLength();
	for(int x = 0; x < Length; x++ )
	{
		Wallpaper[ x ] = Name[ x ];
		
	}
	Wallpaper[ x ] = 0;

	IActiveDesktop *pActiveDesktop = NULL;
	//Create an instance of the Active Desktop
	hr = CoCreateInstance(CLSID_ActiveDesktop, NULL, CLSCTX_INPROC_SERVER,
            IID_IActiveDesktop, (void**)&pActiveDesktop);
	if( hr == S_OK && pActiveDesktop )
	{
		
		WALLPAPEROPT Options;
		COMPONENTSOPT Components ;
		Components.dwSize = sizeof( COMPONENTSOPT );
		//Checking if Active Desktop is enabled
		pActiveDesktop->GetDesktopItemOptions(&Components, 0);
		if( Components.fActiveDesktop == FALSE && !IsBitmap(Name))
		{
			//Enabling Active Desktop
			Components.fActiveDesktop = TRUE;
			pActiveDesktop->SetDesktopItemOptions(&Components, 0);
		}
		Options.dwStyle = Style; 
		Options.dwSize = sizeof( WALLPAPEROPT );
		hr = pActiveDesktop->SetWallpaperOptions(&Options, 0);
		hr = pActiveDesktop->SetWallpaper( Wallpaper,0);
		hr = pActiveDesktop->ApplyChanges( AD_APPLY_ALL | AD_APPLY_REFRESH );
		pActiveDesktop->Release();
		return;
	}
	LPSTR str1;
	SetArrangement( Arrangement );
	int i=Name.GetLength();
	str1=Name.GetBuffer(i);
	::SystemParametersInfo(SPI_SETDESKWALLPAPER,NULL,str1,SPIF_UPDATEINIFILE);
	Name.ReleaseBuffer(i);
	return;
}


void CBackgroundChangerApp::SetArrangement(CString str)
{
	HKEY hKey;
	DWORD disp;
	LPSTR str1;
	int i=str.GetLength();
	str1=str.GetBuffer(i);
	//Set WallpaperStyle
	//Reset Registry Key HKEY_CURRENT_USER\\Control Panel\\Desktop\\WallpaperStyle
	if(RegCreateKeyEx(HKEY_CURRENT_USER, "Control Panel\\Desktop",
		0, NULL, REG_OPTION_NON_VOLATILE ,
		KEY_SET_VALUE,NULL,&hKey,&disp)==ERROR_SUCCESS)
	{
		RegSetValueEx(hKey,"WallpaperStyle",0, REG_SZ,(BYTE * const)"0",2);
		RegSetValueEx(hKey,"TileWallpaper",0, REG_SZ,(BYTE * const)str1,i+1);
		RegCloseKey(hKey);
	}
	else
		AfxMessageBox("Error in changing the wallpaper");
	str.ReleaseBuffer(i);
}


BOOL CBackgroundChangerApp::IsBitmap(const CString & Name)
{
	CString Extension = Name.Right(4);
	if( Extension.CompareNoCase( ".bmp" ) == 0)
		return TRUE;
	else
		return FALSE;
}
